SystemOrganization addCategory: #Tp_estanciero!

Object subclass: #Casillero
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tp_estanciero'!

!Casillero methodsFor: 'as yet unclassified' stamp: 'campos 9/18/2012 14:24'!
cayo:unJugador

"no se hace nada"! !

!Casillero methodsFor: 'as yet unclassified' stamp: 'campos 9/18/2012 14:25'!
paso: unJugador
"no se hace nada"! !

Casillero subclass: #Premio
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tp_estanciero'!

!Premio methodsFor: 'as yet unclassified' stamp: 'campos 9/16/2012 22:17'!
cayo: unJugador
unJugador recibeDinero: 2500.! !

Casillero subclass: #Propiedad
	instanceVariableNames: 'duenio empresas campos precioDePropiedad rentaFija'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tp_estanciero'!

Propiedad subclass: #Campo
	instanceVariableNames: 'cantidadDeEstancias valorDeConstruccionDeEstancia'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tp_estanciero'!

!Campo methodsFor: 'as yet unclassified' stamp: 'campos 9/18/2012 14:31'!
agregarEstanciaEn:provincia pertenecienteA:unJugador
 
(provincia sePuedeConstruir:self)
ifTrue:[self sumarEstancia. self duenio realizarOperacionDe: unJugador en: self]
ifFalse:[self error:'No puede Construir'].! !

!Campo methodsFor: 'as yet unclassified' stamp: 'campos 9/18/2012 14:14'!
precioDePropiedad: unPrecio
precioDePropiedad := unPrecio ! !

!Campo methodsFor: 'as yet unclassified' stamp: 'campos 9/18/2012 14:13'!
rentaFija: unMonto
	rentaFija := unMonto! !

!Campo methodsFor: 'as yet unclassified' stamp: 'campos 9/18/2012 12:26'!
rentaPara: JugadorQuecayo
|cantidadEstancias renta|
renta:=self rentaFija.
cantidadEstancias := self cantidadDeEstancias.
^(2 raisedTo: cantidadEstancias)*renta.
 
! !

!Campo methodsFor: 'as yet unclassified' stamp: 'campos 9/15/2012 18:42'!
sumarEstancia
cantidadDeEstancias := cantidadDeEstancias + 1.! !

!Campo methodsFor: 'as yet unclassified' stamp: 'campos 9/18/2012 14:15'!
valorDeConstruccionDeEstancia: unPrecio
	valorDeConstruccionDeEstancia := unPrecio! !

Propiedad subclass: #Empresa
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tp_estanciero'!

!Empresa methodsFor: 'as yet unclassified' stamp: 'campos 9/18/2012 14:32'!
rentaPara: jugadorQueCayo
|sumaDeDados cantidadDeEmpresasQueTiene|
sumaDeDados := jugadorQueCayo tirarDado.
cantidadDeEmpresasQueTiene:= jugadorQueCayo cantidadDeEmpresas.
^sumaDeDados*30000*cantidadDeEmpresasQueTiene. 
! !

!Propiedad methodsFor: 'as yet unclassified' stamp: 'campos 9/17/2012 09:45'!
cayo: unJugador 
self duenio realizarOperacionDe: unJugador en: unJugador casilleroActual .
! !

!Propiedad methodsFor: 'as yet unclassified' stamp: 'campos 9/18/2012 12:39'!
initialize 
empresas:= OrderedCollection new.! !

!Propiedad methodsFor: 'accessing' stamp: 'campos 9/18/2012 12:44'!
rentaFija
^rentaFija.! !

!Propiedad methodsFor: 'as yet unclassified' stamp: 'campos 9/17/2012 09:40'!
rentaPara: JugadorQueCayo 
! !

!Propiedad methodsFor: 'as yet unclassified' stamp: 'movete 9/16/2012 16:00'!
sosEmpresa
^(empresas includes: self ).! !

Casillero subclass: #Salida
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tp_estanciero'!

!Salida methodsFor: 'as yet unclassified' stamp: 'campos 9/16/2012 22:25'!
cayo: unJugador.! !

!Salida methodsFor: 'as yet unclassified' stamp: 'campos 9/17/2012 14:19'!
paso: unJugador
unJugador recibeDinero: 5000.! !

Object subclass: #Juego
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tp_estanciero'!

!Juego methodsFor: 'as yet unclassified' stamp: 'campos 9/18/2012 14:40'!
queJuege: unJugador
|cantidadAMoverse casillerosAMoverse|
cantidadAMoverse := unJugador tirarDados.
casillerosAMoverse := self tablero casilleros copyFrom: ((unJugador casilleroActual) + 1) to: ((unJugador casilleroActual) + casillerosAMoverse).
unJugador movete: casillerosAMoverse
! !

Object subclass: #Participante
	instanceVariableNames: 'dinero casilleroActual propiedades tablero'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tp_estanciero'!

Participante subclass: #Banco
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tp_estanciero'!

!Banco methodsFor: 'as yet unclassified' stamp: 'campos 9/17/2012 14:11'!
pagarA:otroJugador montoDe:plata
otroJugador recibeDinero:plata.! !

!Banco methodsFor: 'as yet unclassified' stamp: 'campos 9/17/2012 14:20'!
realizarOperacionDe: unJugador en:casillero
|dineroAPagar|
dineroAPagar := casillero precioDePropiedad.
unJugador pagarA: self montoDe: dineroAPagar.

! !

Participante subclass: #Jugador
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tp_estanciero'!

!Jugador methodsFor: 'as yet unclassified' stamp: 'campos 9/18/2012 14:35'!
cantidadDeEmpresas
^self empresasQuePosee size.! !

!Jugador methodsFor: 'as yet unclassified' stamp: 'campos 9/17/2012 13:53'!
casilleroActual
^casilleroActual.! !

!Jugador methodsFor: 'as yet unclassified' stamp: 'campos 9/17/2012 13:52'!
empresasQuePosee
^(self  propiedades select: [:unaPropiedad |  unaPropiedad  sosEmpresa]).! !

!Jugador methodsFor: 'as yet unclassified' stamp: 'campos 9/17/2012 14:22'!
movete: casilleros
|ultimoCasillero|
casilleros do: [:casillero | casilleros  paso:self ].
ultimoCasillero:= casilleros last.
ultimoCasillero  cayo:self .
casilleroActual:= tablero at: (tablero indexOf: ultimoCasillero).
! !

!Jugador methodsFor: 'as yet unclassified' stamp: 'campos 9/18/2012 14:42'!
pagarA:otroJugador montoDe:plata
(self tieneParaPagar:plata) ifTrue:[otroJugador recibeDinero:plata. self pierdeDinero:plata]
ifFalse:[self error: 'No tiene dinero suficiente para realizar esta Operacin'].! !

!Jugador methodsFor: 'as yet unclassified' stamp: 'campos 9/17/2012 13:55'!
pierdeDinero:plata
dinero:= dinero - plata.! !

!Jugador methodsFor: 'as yet unclassified' stamp: 'campos 9/17/2012 14:08'!
realizarOperacionDe: unJugador en:casillero
|renta|
renta:= casillero rentaPara: unJugador.
self pagarA:unJugador montoDe:renta.


! !

!Jugador methodsFor: 'as yet unclassified' stamp: 'campos 9/17/2012 13:54'!
tieneParaPagar: plata
self dinero >= plata.! !

!Jugador methodsFor: 'as yet unclassified' stamp: 'campos 9/17/2012 14:01'!
tirarDados
^((1 to: 6) atRandom) + ((1 to: 6) atRandom)! !

!Participante methodsFor: 'as yet unclassified' stamp: 'campos 9/15/2012 19:33'!
dinero
^dinero.! !

!Participante methodsFor: 'as yet unclassified' stamp: 'campos 9/15/2012 19:35'!
recibeDinero:plata
dinero:= dinero + plata.! !

Object subclass: #Provincia
	instanceVariableNames: 'campos'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tp_estanciero'!

!Provincia methodsFor: 'as yet unclassified' stamp: 'campos 9/17/2012 17:38'!
campos
^campos! !

!Provincia methodsFor: 'as yet unclassified' stamp: 'campos 9/15/2012 17:21'!
construccionPareja: Campo 
^campos allSatisfy: [:unCampo|Campo  cantidadDeEstancias <=unCampo cantidadEstancias].! !

!Provincia methodsFor: 'as yet unclassified' stamp: 'campos 9/15/2012 17:05'!
duenios
^ (campos collect: [:unCampo|unCampo duenio])asSet.! !

!Provincia methodsFor: 'as yet unclassified' stamp: 'campos 9/17/2012 17:34'!
initialize 
campos:= OrderedCollection new.! !

!Provincia methodsFor: 'as yet unclassified' stamp: 'campos 9/18/2012 14:30'!
sePuedeConstruir: unCampo
^(self sosMonopolio) & (self construccionPareja: unCampo).! !

!Provincia methodsFor: 'as yet unclassified' stamp: 'campos 9/15/2012 17:13'!
sosMonopolio 
|cantidadDeDuenios|
cantidadDeDuenios := campos collect: [:unCampo|unCampo duenios].
^(cantidadDeDuenios size) = 1.! !

Object subclass: #Tablero
	instanceVariableNames: 'tablero'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tp_estanciero'!

!Tablero methodsFor: 'as yet unclassified' stamp: 'campos 9/17/2012 17:11'!
initialize 
tablero:= OrderedCollection  new.
! !

!Tablero methodsFor: 'as yet unclassified' stamp: 'campos 9/17/2012 13:45'!
tablero
^tablero.! !
